#include "point.h"

Point::Point( double X, double Y ):
x(X), y(Y)
{
}

Point::Point( Point* p )
{
	if ( this != p )
	{
		x = p->x;
		y = p->y;
	}
}

Point::Point():
x(0), y(0)
{
}

bool operator == (const Point& left, const Point& right)
{
	return left.x == right.x && left.y == right.y;
}

bool operator != (const Point& left, const Point& right)
{
	return ! (left == right);
}

bool operator  < (const Point& left, const Point& right)
{
	return left.x < right.x || (left.x == right.x && left.y < right.y);
}

bool operator  > (const Point& left, const Point& right)
{
	return right < left;
}

bool operator <= (const Point& left, const Point& right)
{
	return ! (left > right);
}

bool operator >= (const Point& left, const Point& right)
{
	return ! (left < right);
}

string Point::toString() const
{
	ostringstream out;
	out << "(" << x << ", " << y << ")";
	return out.str();
}

ostream& operator << (ostream& os, const Point& p)
{
	os << p.toString();
	return os;
}
