#pragma once
#include <iostream>
#include "datatypes.h"
#include "point.h"
using namespace std;

#define SAMPLE_LENGTH -1
//#define SAMPLE_LENGTH 30
#define SS_TIMEOUT 20

typedef pair<Point*, Snapshot> runtimeCell;
class SignalMap
{
	public:
		vector<runtimeCell*> runtimeCells;
		int current_x;
		int current_y;
		static SignalMap* Instance();
		void set( packet* pkg );
		signalStamp* get( const char* source ) const;
		Snapshot* getSnapshot();
		vector<runtimeCell*> getRunCells();
		void clear();
		void dump();
		void writeToFile( char* fileName );
		void writeToFileWithTimestamps( char* fileName );
	protected:
		SignalMap();
		SignalMap(const SignalMap&);
      		SignalMap& operator= (const SignalMap&);
  	private:
      		static SignalMap* pinstance;	
		Snapshot* _map;
};


extern "C" void call_signalmap_set( struct packet* pkg );
extern "C" void call_signalmap_dump();
extern "C" void call_signalmap_writeToFile( char* fileName );
extern "C" void call_signalmap_writeToFileWithTimestamps( char* fileName );
